A YANG Data Model for In Situ Operations, Administration, and Maintenance (IOAM)
RFC 9617
Tianran Zhou, Ed.
Huawei
156 Beiqing Rd.
Beijing
100095
China
zhoutianran@huawei.com
Jim Guichard
Futurewei
United States of America
james.n.guichard@futurewei.com
Frank Brockners
Cisco Systems
Hansaallee 249, 3rd Floor
Düsseldorf, Nordrhein-Westfalen
40549
Germany
fbrockne@cisco.com
Srihari Raghavan
Cisco Systems
Tril Infopark Sez, Ramanujan IT City
Neville Block, 2nd floor, Old Mahabalipuram Road
Chennai
Tamil Nadu
600113
India
srihari@cisco.com
August 2024
OPS
ippm
OAM
Configuration
In situ Operations, Administration, and Maintenance (IOAM) is an example of an on-path hybrid measurement method. IOAM defines a method for producing operational and telemetry information that may be exported using the in-band or out-of-band method. RFCs 9197 and 9326 discuss the data fields and associated data types for IOAM. This document defines a YANG module for the configuration of IOAM functions.
Introduction
In situ Operations, Administration, and Maintenance (IOAM) is an example of an on-path hybrid measurement method. IOAM defines a method for producing operational and telemetry information that may be exported using the in-band or out-of-band method. The data types and data formats for IOAM data records have been defined in [RFC9197] and [RFC9326]. The IOAM data can be embedded in many protocol encapsulations, such as the Network Service Header (NSH) [RFC9452] and IPv6.
This document defines a data model for the configuration of IOAM capabilities using the YANG data modeling language. This YANG data model supports five IOAM options, which are as follows:
- Incremental Trace-Option
- Pre-allocated Trace-Option
- Direct Export Option
- Proof of Transit (POT) Option
- Edge-to-Edge Option
Conventions Used in This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The following terms are defined in [RFC7950] and are used in this specification:
- augment
- data model
- data node
The terminology for describing YANG data models is found in [RFC7950].
Tree Diagrams
Tree diagrams used in this document follow the notation defined in [RFC8340].
Design of the IOAM YANG Data Model
Overview
The IOAM model is organized as a list of profiles, as shown in the following figure. Each profile associates with one flow and the corresponding IOAM information.
module: ietf-ioam
  +--rw ioam
     +--ro info
     |  +--ro timestamp-type?        identityref
     |  +--ro available-interface* [if-name]
     |     +--ro if-name    if:interface-ref
     +--rw admin-config
     |  +--rw enabled?   boolean
     +--rw profiles
        +--rw profile* [profile-name]
           +--rw profile-name                    string
           +--rw filter
           |  +--rw filter-type?   ioam-filter-type
           |  +--rw ace-name?      -> /acl:acls/acl/aces/ace/name
           +--rw protocol-type?                  ioam-protocol-type
           +--rw incremental-tracing-profile {incremental-trace}?
           |  ...
           +--rw preallocated-tracing-profile {preallocated-trace}?
           |  ...
           +--rw direct-export-profile {direct-export}?
           |  ...
           +--rw pot-profile {proof-of-transit}?
           |  ...
           +--rw e2e-profile {edge-to-edge}?

The "info" parameter is a container for all the read-only information that assists monitoring systems in the interpretation of the IOAM data.
The "enabled" parameter is an administrative configuration. When it is set to "true", IOAM configuration is enabled for the system. Meanwhile, the IOAM data plane functionality is enabled.
The "filter" parameter is used to identify a flow, where the IOAM profile can apply. There may be multiple filter types. Access Control Lists (ACLs) provide a common way to specify a flow. Each IOAM profile can associate with an ACE (Access Control Entry). When the matched ACE "forwarding" action is "accept", IOAM actions MUST be driven by the accepted packets.
The IOAM data can be encapsulated into multiple protocols, e.g., IPv6 and the NSH. The "protocol-type" parameter is used to indicate where IOAM is applied. For example, if "protocol-type" is set to "ipv6", the IOAM ingress node will encapsulate the associated flow according to [RFC9486].
In this document, IOAM data includes five encapsulation types, i.e., incremental tracing data, pre-allocated tracing data, direct export data, proof of transit data, and end-to-end data. In practice, multiple IOAM data types can be encapsulated into the same IOAM header. The "profile" parameter contains a set of sub-profiles, each of which relates to one encapsulation type. The configured object may not support all the sub-profiles. The supported sub-profiles are indicated by five defined features, i.e., "incremental-trace", "preallocated-trace", "direct-export", "proof-of-transit", and "edge-to-edge".
This document uses the "ietf-access-control-list" YANG module, the "ietf-interfaces" YANG module, and the "ietf-lime-time-types" YANG module.
The YANG data model in this document conforms to the Network Management Datastore Architecture (NMDA) defined in [RFC8342].
Pre-allocated Tracing Profile
To ensure visibility into the entire path that a packet takes within an IOAM domain, the IOAM tracing data is expected to be collected at every node that a packet traverses. The Pre-allocated Trace-Option will create pre-allocated space for each node to populate its information. The "preallocated-tracing-profile" parameter contains the detailed information for the pre-allocated tracing data. This information includes:
node-action:
indicates the operation (e.g., encapsulate the IOAM header, transit the IOAM data, or decapsulate the IOAM header) applied to the dedicated flow.
use-namespace:
indicates the namespace used for the trace types.
trace-type:
indicates the per-hop data to be captured by IOAM-enabled nodes and included in the node data list.
max-length:
specifies the maximum length of the node data list in octets. "max-length" is only defined at the encapsulation node.
+--rw preallocated-tracing-profile {preallocated-trace}?
   +--rw node-action?            ioam-node-action
   +--rw trace-types
   |  +--rw use-namespace?   ioam-namespace
   |  +--rw trace-type*   ioam-trace-type
   +--rw max-length?             uint32

Incremental Tracing Profile
The Incremental Trace-Option contains a variable-length list of node data fields, where each node allocates and pushes its node data immediately following the option header. The "incremental-tracing-profile" parameter contains the detailed information for the incremental tracing data. This information is the same as that for the Pre-allocated Tracing Profile; see Section 3.2.
+--rw incremental-tracing-profile {incremental-trace}?
   +--rw node-action?            ioam-node-action
   +--rw trace-types
   |  +--rw use-namespace?   ioam-namespace
   |  +--rw trace-type*   ioam-trace-type
   +--rw max-length?             uint32

Direct Export Profile
The Direct Export Option is used as a trigger for IOAM data to be directly exported or locally aggregated without being pushed into in-flight data packets. The "direct-export-profile" parameter contains the detailed information for the direct export data. This information is the same as that for the Pre-allocated Tracing Profile (Section 3.2), but with two more optional variables:
flow-id:
used to correlate the exported data of the same flow from multiple nodes and from multiple packets.
enable-sequence-number:
indicates whether the sequence number is used in the Direct Export Option.
+--rw direct-export-profile {direct-export}?
   +--rw node-action?            ioam-node-action
   +--rw trace-types
   |  +--rw use-namespace?   ioam-namespace
   |  +--rw trace-type*      ioam-trace-type
   +--rw flow-id?             uint32
   +--rw enable-sequence-number? boolean

Proof of Transit Profile
The IOAM proof of transit data is used to support the path or service function chain verification use cases. The "pot-profile" parameter is intended to contain the detailed information for the proof of transit data. The "use-namespace" parameter indicates the namespace used for the POT types. The "pot-type" parameter indicates a particular POT variant that specifies the POT data that is included. There may be several POT types, each having different configuration data. To align with [RFC9197], this document only defines IOAM POT type 0. Users need to augment this module for the configuration of a specific POT type.
+--rw pot-profile {proof-of-transit}?
   +--rw use-namespace?   ioam-namespace
   +--rw pot-type?   ioam-pot-type

Edge-to-Edge Profile
The IOAM Edge-to-Edge Option is used to carry data that is added by the IOAM encapsulating node and interpreted by the IOAM decapsulating node. The "e2e-profile" parameter contains the detailed information for the edge-to-edge data. This information includes:
node-action:
the same semantic as that provided in Section 3.2.
use-namespace:
indicates the namespace used for the edge-to-edge types.
e2e-type:
indicates data to be carried from the ingress IOAM node to the egress IOAM node.
+--rw e2e-profile {edge-to-edge}?
   +--rw node-action?   ioam-node-action
   +--rw e2e-types
      +--rw use-namespace?   ioam-namespace
      +--rw e2e-type*        ioam-e2e-type

IOAM YANG Module
The "ietf-ioam" module defined in this document imports typedefs from [RFC8519], [RFC8343], and [RFC8532]. This document also references [RFC9197], [RFC9326], [RFC9486], and [RFC9452].

module ietf-ioam {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-ioam";
  prefix ioam;

  import ietf-access-control-list {
    prefix acl;
    reference
      "RFC 8519: YANG Data Model for Network Access Control
       Lists (ACLs)";
  }
  import ietf-interfaces {
    prefix if;
    reference
      "RFC 8343: A YANG Data Model for Interface Management";
  }
  import ietf-lime-time-types {
    prefix lime;
    reference
      "RFC 8532: Generic YANG Data Model for the Management of
       Operations, Administration, and Maintenance (OAM) Protocols
       That Use Connectionless Communications";
  }

  organization
    "IETF IPPM (IP Performance Measurement) Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/ippm>
     WG List:  <mailto:ippm@ietf.org>
     Editor:   Tianran Zhou
               <mailto:zhoutianran@huawei.com>
     Author:   Jim Guichard
               <mailto:james.n.guichard@futurewei.com>
     Author:   Frank Brockners
               <mailto:fbrockne@cisco.com>
     Author:   Srihari Raghavan
               <mailto:srihari@cisco.com>";
  description
    "This YANG module specifies a vendor-independent data model
     for In Situ Operations, Administration, and Maintenance
     (IOAM).

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL', 'SHALL
     NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED', 'NOT RECOMMENDED',
     'MAY', and 'OPTIONAL' in this document are to be interpreted as
     described in BCP 14 (RFC 2119) (RFC 8174) when, and only when,
     they appear in all capitals, as shown here.

     Copyright (c) 2024 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject to
     the license terms contained in, the Revised BSD License set
     forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC 9617; see the
     RFC itself for full legal notices.";

  revision 2024-08-27 {
    description
      "Initial revision.";
    reference
      "RFC 9617: A YANG Data Model for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  /*
   * FEATURES
   */

  feature incremental-trace {
    description
      "This feature indicates that the Incremental Trace-Option is
       supported.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  feature preallocated-trace {
    description
      "This feature indicates that the Pre-allocated Trace-Option
       is supported.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  feature direct-export {
    description
      "This feature indicates that the Direct Export Option is
       supported.";
    reference
      "RFC 9326: In Situ Operations, Administration, and
       Maintenance (IOAM) Direct Exporting";
  }

  feature proof-of-transit {
    description
      "This feature indicates that the Proof of Transit Option is
       supported.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  feature edge-to-edge {
    description
      "This feature indicates that the Edge-to-Edge Option is
       supported.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  /*
   * IDENTITIES
   */

  identity filter {
    description
      "Base identity to represent a filter.  A filter is used to
       specify the flow to apply the IOAM profile.";
  }

  identity acl-filter {
    base filter;
    description
      "Apply Access Control List (ACL) rules to specify the
       flow.";
  }

  identity protocol {
    description
      "Base identity to represent the carrier protocol.  It is
       used to indicate in what layer and protocol the IOAM data
       is embedded.";
  }

  identity ipv6 {
    base protocol;
    description
      "The described IOAM data is embedded in IPv6.";
    reference
      "RFC 9486: IPv6 Options for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  identity nsh {
    base protocol;
    description
      "The described IOAM data is embedded in the Network Service
       Header (NSH).";
    reference
      "RFC 9452: Network Service Header (NSH) Encapsulation for
       In Situ OAM (IOAM) Data";
  }

  identity node-action {
    description
      "Base identity to represent the node actions.  It is used to
       indicate what action the node will take.";
  }

  identity action-encapsulate {
    base node-action;
    description
      "This identity indicates that the node is used to
       encapsulate the IOAM packet.";
  }

  identity action-decapsulate {
    base node-action;
    description
      "This identity indicates that the node is used to
       decapsulate the IOAM packet.";
  }

  identity action-transit {
    base node-action;
    description
      "This identity indicates that the node is used to transit
       the IOAM packet.";
  }

  identity trace-type {
    description
      "Base identity to represent trace types.";
  }

  identity trace-hop-lim-node-id {
    base trace-type;
    description
      "This identity indicates the presence of 'Hop_Lim' and
       'node_id' in the node data.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  identity trace-if-id {
    base trace-type;
    description
      "This identity indicates the presence of 'ingress_if_id' and
       'egress_if_id' (short format) in the node data.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  identity trace-timestamp-seconds {
    base trace-type;
    description
      "This identity indicates the presence of timestamp seconds
       in the node data.";
  }

  identity trace-timestamp-fraction {
    base trace-type;
    description
      "This identity indicates the presence of a timestamp
       fraction in the node data.";
  }

  identity trace-transit-delay {
    base trace-type;
    description
      "This identity indicates the presence of transit delay in
       the node data.";
  }

  identity trace-namespace-data {
    base trace-type;
    description
      "This identity indicates the presence of namespace-specific
       data (short format) in the node data.";
  }

  identity trace-queue-depth {
    base trace-type;
    description
      "This identity indicates the presence of queue depth in the
       node data.";
  }

  identity trace-checksum-complement {
    base trace-type;
    description
      "This identity indicates the presence of the Checksum
       Complement in the node data.";
    reference
      "RFC 9197: Data Fields for In Situ Operations,
       Administration, and Maintenance (IOAM)";
  }

  identity trace-hop-lim-node-id-wide {
    base trace-type;
    description
      "This identity indicates the presence of 'Hop_Lim' and
       'node_id' (wide format) in the node data.";
  }

  identity trace-if-id-wide {
    base trace-type;
    description
      "This identity indicates the presence of 'ingress_if_id' and
       'egress_if_id' (wide format) in the node data.";
  }

  identity trace-namespace-data-wide {
    base trace-type;
    description
      "This identity indicates the presence of
       IOAM-namespace-specific data (wide format) in the
       node data.";
  }

  identity trace-buffer-occupancy {
    base trace-type;
    description
      "This identity indicates the presence of buffer occupancy
       in the node data.";
  }

  identity trace-opaque-state-snapshot {
    base trace-type;
    description
      "This identity indicates the presence of the variable-length
       Opaque State Snapshot field.";
  }

  identity pot-type {
    description
      "Base identity to represent Proof of Transit (POT) types.";
  }

  identity pot-type-0 {
    base pot-type;
    description
      "The IOAM field value for the POT type is 0, and POT data is
       a 16-octet field to carry data associated with POT
       procedures.";
  }

  identity e2e-type {
    description
      "Base identity to represent edge-to-edge types.";
  }

  identity e2e-seq-num-64 {
    base e2e-type;
    description
      "This identity indicates the presence of a 64-bit
       sequence number.";
  }

  identity e2e-seq-num-32 {
    base e2e-type;
    description
      "This identity indicates the presence of a 32-bit
       sequence number.";
  }

  identity e2e-timestamp-seconds {
    base e2e-type;
    description
      "This identity indicates the presence of timestamp seconds
       representing the time at which the packet entered the
       IOAM domain.";
  }

  identity e2e-timestamp-fraction {
    base e2e-type;
    description
      "This identity indicates the presence of a timestamp
       fraction representing the time at which the packet entered
       the IOAM domain.";
  }

  identity namespace {
    description
      "Base identity to represent the Namespace-ID.";
  }

  identity default-namespace {
    base namespace;
    description
      "The Namespace-ID value of 0x0000 is defined as the
       Default-Namespace-ID and MUST be known to all the nodes
       implementing IOAM.";
  }

  /*
   * TYPE DEFINITIONS
   */

  typedef ioam-filter-type {
    type identityref {
      base filter;
    }
    description
      "This type specifies a known type of filter.";
  }

  typedef ioam-protocol-type {
    type identityref {
      base protocol;
    }
    description
      "This type specifies a known type of carrier protocol for
       the IOAM data.";
  }

  typedef ioam-node-action {
    type identityref {
      base node-action;
    }
    description
      "This type specifies a known type of node action.";
  }

  typedef ioam-trace-type {
    type identityref {
      base trace-type;
    }
    description
      "This type specifies a known trace type.";
  }

  typedef ioam-pot-type {
    type identityref {
      base pot-type;
    }
    description
      "This type specifies a known POT type.";
  }

  typedef ioam-e2e-type {
    type identityref {
      base e2e-type;
    }
    description
      "This type specifies a known edge-to-edge type.";
  }

  typedef ioam-namespace {
    type identityref {
      base namespace;
    }
    description
      "This type specifies the supported namespace.";
  }

  /*
   * GROUP DEFINITIONS
   */

  grouping ioam-filter {
    description
      "A grouping for IOAM filter definitions.";
    leaf filter-type {
      type ioam-filter-type;
      description
        "Filter type.";
    }
    leaf ace-name {
      when "derived-from-or-self(../filter-type, 'ioam:acl-filter')";
      type leafref {
        path "/acl:acls/acl:acl/acl:aces/acl:ace/acl:name";
      }
      description
        "The Access Control Entry name is used to refer to an ACL
         specification.";
    }
  }

  grouping encap-tracing {
    description
      "A grouping for the generic configuration for the
       tracing profile.";
    container trace-types {
      description
        "This container provides the list of trace types for
         encapsulation.";
      leaf use-namespace {
        type ioam-namespace;
        default "default-namespace";
        description
          "This object indicates the namespace used for
           encapsulation.";
      }
      leaf-list trace-type {
        type ioam-trace-type;
        description
          "The trace type is only defined at the encapsulation
           node.";
      }
    }
    leaf max-length {
      when "derived-from-or-self(../node-action,
            'ioam:action-encapsulate')";
      type uint32;
      units "bytes";
      description
        "This field specifies the maximum length of the node data
         list in octets.  'max-length' is only defined at the
         encapsulation node.";
    }
  }

  grouping ioam-incremental-tracing-profile {
    description
      "A grouping for the Incremental Tracing Profile.";
    leaf node-action {
      type ioam-node-action;
      default "action-transit";
      description
        "This object indicates the action the node needs to
         take, e.g., encapsulation.";
    }
    uses encap-tracing {
      when "derived-from-or-self(node-action,
            'ioam:action-encapsulate')";
    }
  }

  grouping ioam-preallocated-tracing-profile {
    description
      "A grouping for the Pre-allocated Tracing Profile.";
    leaf node-action {
      type ioam-node-action;
      default "action-transit";
      description
        "This object indicates the action the node needs to
         take, e.g., encapsulation.";
    }
    uses encap-tracing {
      when "derived-from-or-self(node-action,
            'ioam:action-encapsulate')";
    }
  }

  grouping ioam-direct-export-profile {
    description
      "A grouping for the Direct Export Profile.";
    leaf node-action {
      type ioam-node-action;
      default "action-transit";
      description
        "This object indicates the action the node needs to
         take, e.g., encapsulation.";
    }
    uses encap-tracing {
      when "derived-from-or-self(node-action,
            'ioam:action-encapsulate')";
    }
    leaf flow-id {
      when "derived-from-or-self(../node-action,
            'ioam:action-encapsulate')";
      type uint32;
      description
        "A 32-bit flow identifier.  The field is set at the
         encapsulating node.  The Flow ID can be uniformly
         assigned by a central controller or algorithmically
         generated by the encapsulating node.  The latter approach
         cannot guarantee the uniqueness of the Flow ID, yet the
         probability of conflict is small due to the large Flow ID
         space.  'flow-id' is used to correlate the exported data
         of the same flow from multiple nodes and from multiple
         packets.";
    }
    leaf enable-sequence-number {
      when "derived-from-or-self(../node-action,
            'ioam:action-encapsulate')";
      type boolean;
      default "false";
      description
        "This boolean value indicates whether the sequence number
         is used in the Direct Export Option's 32-bit flow
         identifier.  If this value is set to 'true', the sequence
         number is used.  It is turned off by default.";
    }
  }

  grouping ioam-e2e-profile {
    description
      "A grouping for the Edge-to-Edge Profile.";
    leaf node-action {
      type ioam-node-action;
      default "action-transit";
      description
        "This object indicates the action the node needs to
         take, e.g., encapsulation.";
    }
    container e2e-types {
      when "derived-from-or-self(../node-action,
            'ioam:action-encapsulate')";
      description
        "This container provides the list of edge-to-edge types
         for encapsulation.";
      leaf use-namespace {
        type ioam-namespace;
        default "default-namespace";
        description
          "This object indicates the namespace used for
           encapsulation.";
      }
      leaf-list e2e-type {
        type ioam-e2e-type;
        description
          "The edge-to-edge type is only defined at the
           encapsulation node.";
      }
    }
  }

  grouping ioam-admin-config {
    description
      "IOAM top-level administrative configuration.";
    leaf enabled {
      type boolean;
      default "false";
      description
        "This object is used to control the availability of
         configuration.  It MUST be set to 'true' before anything
         in the /ioam/profiles/profile subtree can be edited.
         If 'false', any configuration in place is not used.";
    }
  }

  /*
   * DATA NODES
   */

  container ioam {
    description
      "IOAM top-level container.";
    container info {
      config false;
      description
        "Describes information, such as units or timestamp format,
         that assists monitoring systems in the interpretation of
         the IOAM data.";
      leaf timestamp-type {
        type identityref {
          base lime:timestamp-type;
        }
        description
          "Type of timestamp, such as Truncated PTP (Precision
           Time Protocol) or NTP.";
      }
      list available-interface {
        key "if-name";
        description
          "A list of available interfaces that support IOAM.";
        leaf if-name {
          type if:interface-ref;
          description
            "This is a reference to the interface name.";
        }
      }
    }
    container admin-config {
      description
        "Contains all the administrative configurations related to
         the IOAM functionalities and all the IOAM profiles.";
      uses ioam-admin-config;
    }
    container profiles {
      description
        "Contains a list of IOAM profiles.";
      list profile {
        key "profile-name";
        description
          "A list of IOAM profiles that are configured on the
           node.  There is no mandatory type of profile (e.g.,
           'incremental-trace', 'preallocated-trace') in the list.
           But at least one profile should be added.";
        leaf profile-name {
          type string {
            length "1..300";
          }
          description
            "Unique identifier for each IOAM profile.";
        }
        container filter {
          uses ioam-filter;
          description
            "The filter that is used to indicate the flow to apply
             IOAM.";
        }
        leaf protocol-type {
          type ioam-protocol-type;
          description
            "This object is used to indicate the carrier protocol
             where IOAM is applied.";
        }
        container incremental-tracing-profile {
          if-feature "incremental-trace";
          presence "Enables the Incremental Trace-Option.";
          description
            "This container describes the profile for the
             Incremental Trace-Option.";
          uses ioam-incremental-tracing-profile;
        }
        container preallocated-tracing-profile {
          if-feature "preallocated-trace";
          presence "Enables the Pre-allocated Trace-Option.";
          description
            "This container describes the profile for the
             Pre-allocated Trace-Option.";
          uses ioam-preallocated-tracing-profile;
        }
        container direct-export-profile {
          if-feature "direct-export";
          presence "Enables the Direct Export Option.";
          description
            "This container describes the profile for the
             Direct Export Option.";
          uses ioam-direct-export-profile;
        }
        container pot-profile {
          if-feature "proof-of-transit";
          presence "Enables the Proof of Transit Option.";
          description
            "This container describes the profile for the
             Proof of Transit Option.";
          leaf use-namespace {
            type ioam-namespace;
            default "default-namespace";
            description
              "This object indicates the namespace used for the
               POT types.";
          }
          leaf pot-type {
            type ioam-pot-type;
            description
              "The type of a particular POT variant that specifies
               the POT data that is included.";
          }
        }
        container e2e-profile {
          if-feature "edge-to-edge";
          presence "Enables the Edge-to-Edge Option.";
          description
            "This container describes the profile for the
             Edge-to-Edge Option.";
          uses ioam-e2e-profile;
        }
      }
    }
  }
}

Security Considerations
The YANG module specified in this document defines a schema for data that is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer, and the mandatory-to-implement secure transport is Secure Shell (SSH) [RFC6242]. The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446].
The Network Configuration Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and content.
There are a number of data nodes defined in this YANG module that are writable/creatable/deletable (i.e., config true, which is the default). These data nodes may be considered sensitive or vulnerable in some network environments. Write operations (e.g., edit-config) to these data nodes without proper protection can have a negative effect on network operations. These are the subtrees and data nodes and their sensitivity/vulnerability:
/ioam/admin-config:
The items in the "admin-config" container above include the top-level administrative configurations related to the IOAM functionalities and all the IOAM profiles. Unexpected changes to these items could lead to disruption of IOAM functions and/or misbehaving IOAM profiles.
/ioam/profiles/profile:
The entries in the "profile" list above include the whole IOAM profile configurations. Unexpected changes to these entries could lead to incorrect IOAM behavior for the corresponding flows. Consequently, such changes would impact performance monitoring, data analytics, and associated interactions with network services.
Some of the readable data nodes in this YANG module may be considered sensitive or vulnerable in some network environments. It is thus important to control read access (e.g., via get, get-config, or notification) to these data nodes. These are the subtrees and data nodes and their sensitivity/vulnerability:
/ioam/profiles/profile:
The information contained in this subtree might reveal information about the services deployed for customers. For instance, a customer might be given access to monitor the status of their services. In this scenario, the customer's access should be restricted to nodes representing their services so as not to divulge information about the underlying network structure or services.
IANA Considerations
IANA has registered the following URI in the "IETF XML Registry":
URI:
urn:ietf:params:xml:ns:yang:ietf-ioam
Registrant Contact:
The IESG.
XML:
N/A; the requested URI is an XML namespace.
IANA has registered the following YANG module in the "YANG Module Names" registry:
Name:
ietf-ioam
Namespace:
urn:ietf:params:xml:ns:yang:ietf-ioam
Prefix:
ioam
Reference:
RFC 9617
Normative References
[W3C.REC-xml11-20060816]

Extensible Markup Language (XML) 1.1 (Second Edition)
Tim Bray
Jean Paoli
Michael Sperberg-McQueen
Eve Maler
François Yergeau
John Cowan
August 2006
W3C Consortium Recommendation REC-xml11-20060816
[RFC9197]
[RFC9326]
[RFC9452]
[RFC2119]
[RFC8174]
[RFC7950]
[RFC8340]
[RFC9486]
[RFC8342]
[RFC8519]
[RFC8343]
[RFC8532]
[RFC6241]
[RFC8040]
[RFC6242]
[RFC8446]
[RFC8341]
An Example of the Incremental Tracing Profile
An XML example (per [W3C.REC-xml11-20060816]) of the Incremental Tracing Profile is depicted in the following figure. This configuration is received by an IOAM ingress node. This node encapsulates the IOAM data in the IPv6 Hop-by-Hop option header. The trace type indicates that each on-path node needs to capture the transit delay and add the data to the IOAM node data list. The incremental tracing data space is variable; however, the node data list must not exceed 512 bytes.
<rpc xmlns="urn:ietf:params:xml:ns:netconf:base:1.0"
     message-id="101">
  <edit-config>
    <target>
      <candidate/>
    </target>
    <config>
      <ioam xmlns="urn:ietf:params:xml:ns:yang:ietf-ioam">
        <admin-config>
          <enabled>true</enabled>
        </admin-config>
        <profiles>
          <profile>
            <profile-name>ietf-test-profile</profile-name>
            <protocol-type>ipv6</protocol-type>
            <incremental-tracing-profile>
              <node-action>action-encapsulate</node-action>
              <trace-types>
                <use-namespace>default-namespace</use-namespace>
                <trace-type>trace-transit-delay</trace-type>
              </trace-types>
              <max-length>512</max-length>
            </incremental-tracing-profile>
          </profile>
        </profiles>
      </ioam>
    </config>
  </edit-config>
</rpc>

An Example of the Pre-allocated Tracing Profile
An example of the Pre-allocated Tracing Profile is depicted in the following figure. This configuration is received by an IOAM ingress node. This node first identifies the target flow by using the ACL parameter "test-acl" and then encapsulates the IOAM data in the NSH. The trace type indicates that each on-path node needs to capture the namespace-specific data in short format and add the data to the IOAM node data list. This node pre-allocates the node data list in the packet with 512 bytes.
<rpc xmlns="urn:ietf:params:xml:ns:netconf:base:1.0"
     message-id="101">
  <edit-config>
    <target>
      <candidate/>
    </target>
    <config>
      <ioam xmlns="urn:ietf:params:xml:ns:yang:ietf-ioam">
        <admin-config>
          <enabled>true</enabled>
        </admin-config>
        <profiles>
          <profile>
            <profile-name>ietf-test-profile</profile-name>
            <filter>
              <filter-type>acl-filter</filter-type>
              <ace-name>test-acl</ace-name>
            </filter>
            <protocol-type>nsh</protocol-type>
            <preallocated-tracing-profile>
              <node-action>action-encapsulate</node-action>
              <trace-types>
                <use-namespace>default-namespace</use-namespace>
                <trace-type>trace-namespace-data</trace-type>
              </trace-types>
              <max-length>512</max-length>
            </preallocated-tracing-profile>
          </profile>
        </profiles>
      </ioam>
    </config>
  </edit-config>
</rpc>

An Example of the Direct Export Profile
An example of the Direct Export Profile is depicted in the following figure. This configuration is received by an IOAM egress node. This node detects the IOAM Direct Export Option in the IPv6 extension header and removes the option to clean all the IOAM data.
<rpc xmlns="urn:ietf:params:xml:ns:netconf:base:1.0"
     message-id="101">
  <edit-config>
    <target>
      <candidate/>
    </target>
    <config>
      <ioam xmlns="urn:ietf:params:xml:ns:yang:ietf-ioam">
        <admin-config>
          <enabled>true</enabled>
        </admin-config>
        <profiles>
          <profile>
            <profile-name>ietf-test-profile</profile-name>
            <protocol-type>ipv6</protocol-type>
            <direct-export-profile>
              <node-action>action-decapsulate</node-action>
            </direct-export-profile>
          </profile>
        </profiles>
      </ioam>
    </config>
  </edit-config>
</rpc>

An Example of the Proof of Transit Profile
A simple example of the Proof of Transit Profile is depicted in the following figure. This configuration indicates the node to apply POT type 0 with IPv6 encapsulation.
<rpc xmlns="urn:ietf:params:xml:ns:netconf:base:1.0"
     message-id="101">
  <edit-config>
    <target>
      <candidate/>
    </target>
    <config>
      <ioam xmlns="urn:ietf:params:xml:ns:yang:ietf-ioam">
        <admin-config>
          <enabled>true</enabled>
        </admin-config>
        <profiles>
          <profile>
            <profile-name>ietf-test-profile</profile-name>
            <protocol-type>ipv6</protocol-type>
            <pot-profile>
              <pot-type>pot-type-0</pot-type>
            </pot-profile>
          </profile>
        </profiles>
      </ioam>
    </config>
  </edit-config>
</rpc>

An Example of the Edge-to-Edge Profile
An example of the Edge-to-Edge Profile is depicted in the following figure. This configuration is received by an IOAM egress node. This node detects the IOAM Edge-to-Edge Option in the IPv6 extension header and removes the option to clean all the IOAM data. As the IOAM egress node, it may collect the edge-to-edge data and deliver it to the data-exporting process.
<rpc xmlns="urn:ietf:params:xml:ns:netconf:base:1.0"
     message-id="101">
  <edit-config>
    <target>
      <candidate/>
    </target>
    <config>
      <ioam xmlns="urn:ietf:params:xml:ns:yang:ietf-ioam">
        <admin-config>
          <enabled>true</enabled>
        </admin-config>
        <profiles>
          <profile>
            <profile-name>ietf-test-profile</profile-name>
            <protocol-type>ipv6</protocol-type>
            <e2e-profile>
              <node-action>action-decapsulate</node-action>
            </e2e-profile>
          </profile>
        </profiles>
      </ioam>
    </config>
  </edit-config>
</rpc>

Acknowledgements
For their valuable comments, discussions, and feedback, we wish to acknowledge Greg Mirsky, Reshad Rahman, Tom Petch, Mickey Spiegel, Thomas Graf, Alex Huang Feng, and Justin Iurman.